// Generated by dts-bundle v0.7.3

declare module 'foundation' {
    export * from 'foundation/NSPoint';
    export * from 'foundation/NSRange';
    export * from 'foundation/NSRect';
    export * from 'foundation/NSSize';
    export * from 'foundation/NSObject';
    export * from 'foundation/NSNull';
    export * from 'foundation/NSError';
    export * from 'foundation/NSCoder';
    export * from 'foundation/NSKeyedUnarchiver';
    export * from 'foundation/NSDecimalNumber';
    export * from 'foundation/NSDate';
    export * from 'foundation/NSUUID';
    export * from 'foundation/NSPredicate';
    export * from 'foundation/NSSet';
    export * from 'foundation/NSIndexPath';
    export * from 'foundation/NSLocale';
    export * from 'foundation/NSFormatter';
    export * from 'foundation/NSDateFormatter';
    export * from 'foundation/NSISO8601DateFormatter';
    export * from 'foundation/NSNumberFormatter';
    export * from 'foundation/NSTimer';
    export * from 'foundation/NSNotificationCenter';
    export * from 'foundation/NSUserDefaults';
    export * from 'foundation/NSURL';
    export * from 'foundation/NSURLRequest';
    export * from 'foundation/NSURLConnection';
    export * from 'foundation/NSXMLParser';
    export * from 'foundation/NSOperation';
    export * from 'foundation/NSOperationQueue';
    export * from 'foundation/NSBundle';
    export * from 'foundation/NSLog';
    export * from 'foundation/NSNumber';
    export * from 'foundation/NSSortDescriptor';
    export * from 'foundation/NSPropertyListSerialization';
}

declare module 'foundation/NSPoint' {
    export class NSPoint {
        x: number;
        y: number;
        static Zero(): NSPoint;
        constructor(x: any, y: any);
    }
}

declare module 'foundation/NSRange' {
    export class NSRange {
        location: number;
        length: number;
        constructor(location: any, length: any);
    }
    export function NSMaxRange(range: NSRange): number;
    export function NSEqualRanges(range1: NSRange, range2: NSRange): boolean;
    export function NSLocationInRange(location: number, range: NSRange): boolean;
    export function NSIntersectionRange(range1: NSRange, range2: NSRange): NSRange;
    export function NSUnionRange(range1: NSRange, range2: NSRange): NSRange;
}

declare module 'foundation/NSRect' {
    import { NSPoint } from "foundation/NSPoint";
    import { NSSize } from "foundation/NSSize";
    export class NSRect {
        origin: NSPoint;
        size: NSSize;
        static Zero(): NSRect;
        static rectWithValues(x: any, y: any, w: any, h: any): NSRect;
        constructor(p: any, s: any);
    }
}

declare module 'foundation/NSSize' {
    export class NSSize {
        width: number;
        height: number;
        static Zero(): NSSize;
        constructor(w: any, h: any);
        isEqualTo(size: any): boolean;
    }
}

declare module 'foundation/NSObject' {
    /**
      * Created by godshadow on 26/3/16.
      */
    export class NSObject {
        getClassName(): string;
        readonly className: string;
        keyPaths: {};
        init(): void;
        willChangeValueForKey(key: string): void;
        didChangeValueForKey(key: string): void;
        willChangeValue(key: string): void;
        didChangeValue(key: string): void;
        addObserver(obs: any, keypath: string, context?: any): void;
        removeObserver(obs: any, keypath: string): void;
        setValueForKey(value: any, key: string): void;
        valueForKey(key: string): any;
        valueForKeyPath(keyPath: string): any;
        copy(): any;
    }
}

declare module 'foundation/NSNull' {
    import { NSObject } from "foundation/NSObject";
    export class NSNull extends NSObject {
        static nullValue(): NSNull;
    }
}

declare module 'foundation/NSError' {
    import { NSObject } from "foundation/NSObject";
    export class NSError extends NSObject {
        errorCode: number;
    }
}

declare module 'foundation/NSCoder' {
    import { NSObject } from "foundation/NSObject";
    export interface NSCoding {
        initWithCoder?(coder: NSCoder): void;
        encodeWithCoder?(coder: NSCoder): void;
    }
    export class NSCoder extends NSObject {
        decodeIntegerForKey(key: string): any;
        decodeObjectForKey(key: string): any;
    }
}

declare module 'foundation/NSKeyedUnarchiver' {
    import { NSCoder } from "foundation/NSCoder";
    export class NSKeyedUnarchiver extends NSCoder {
        static unarchiveTopLevelObjectWithData(data: string): any;
        _parseData(data: string, error: any): any;
        decodeObjectForKey(key: string): any;
    }
}

declare module 'foundation/NSDecimalNumber' {
    import { NSNumber } from "foundation/NSNumber";
    export class NSDecimalNumber extends NSNumber {
        static decimalNumberWithString(str: string): NSDecimalNumber;
        static one(): NSDecimalNumber;
        static zero(): NSDecimalNumber;
        static numberWithBool(value: any): NSDecimalNumber;
        static numberWithInteger(value: any): NSDecimalNumber;
        static numberWithFloat(value: any): NSDecimalNumber;
        initWithString(str: string): void;
        initWithDecimal(value: any): void;
        _initWithValue(value: any): void;
        decimalNumberByAdding(value: NSDecimalNumber): NSDecimalNumber;
        decimalNumberBySubtracting(value: NSDecimalNumber): NSDecimalNumber;
        decimalNumberByMultiplyingBy(value: NSDecimalNumber): NSDecimalNumber;
        decimalNumberByDividingBy(value: NSDecimalNumber): NSDecimalNumber;
        readonly decimalValue: any;
        readonly floatValue: any;
    }
}

declare module 'foundation/NSDate' {
    /**
      * Created by godshadow on 11/3/16.
      */
    export enum NSDateFirstWeekDay {
        Sunday = 0,
        Monday = 1
    }
    export function NSDateSetFirstWeekDay(day: NSDateFirstWeekDay): void;
    export function NSDateGetStringForMonth(month: any): string;
    export function NSDateGetStringForDay(day: number): string;
    export function NSDateGetDayFromDate(date: any): any;
    export function NSDateGetMonthFromDate(date: Date): number;
    export function NSDateGetYearFromDate(date: Date): number;
    export function NSDateGetDayStringFromDate(date: any): string;
    export function NSDateGetString(date: any): string;
    export function NSDateGetDateString(date: any): string;
    export function NSDateGetTimeString(date: any): string;
    export function NSDateGetUTCString(date: any): string;
    export function NSDateGetUTCDateString(date: any): string;
    export function NSDateGetUTCTimeString(date: any): string;
    export function NSDateFromString(string: any): Date;
    export function NSDateToUTC(date: any): Date;
    export function NSDateAddDaysToDateString(dateString: any, days: any): string;
    export function NSDateRemoveDaysToDateString(dateString: any, days: any): string;
    export function NSDateFromMiliseconds(miliseconds: any): Date;
    export function isDate(x: any): boolean;
    export function NSDateToday(): Date;
    export function NSDateNow(): Date;
    export function NSDateTodayString(): string;
    export function NSDateYesterday(): Date;
    export function NSDateTomorrow(): Date;
    export function NSDateGetFirstDayOfTheWeek(date: Date): Date;
    export function NSDateGetLastDayOfTheWeek(date: Date): Date;
    export function NSDateGetFirstDateOfTheMonth(month: any, year: any): Date;
    export function NSDateGetFirstDayOfTheMonth(month: any, year: any): number;
    export function NSDateGetLastDateOfTheMonth(month: any, year: any): Date;
    export function NSDateGetLastDayOfTheMonth(month: any, year: any): number;
    export function NSDateCopy(date: Date): Date;
}

declare module 'foundation/NSUUID' {
    import { NSObject } from "foundation/NSObject";
    /**
      * Created by godshadow on 15/3/16.
      */
    export class NSUUID extends NSObject {
        static UUID(): NSUUID;
        init(): void;
        readonly UUIDString: string;
    }
}

declare module 'foundation/NSPredicate' {
    import { NSObject } from "foundation/NSObject";
    /**
      * Created by godshadow on 1/5/16.
      */
    export enum NSPredicateComparatorType {
        Equal = 0,
        Less = 1,
        LessOrEqual = 2,
        Greater = 3,
        GreaterOrEqual = 4,
        Distinct = 5,
        Contains = 6,
        NotContains = 7,
        In = 8,
        NotIn = 9
    }
    export enum NSPredicateRelationshipOperatorType {
        ANY = 0,
        ALL = 1
    }
    export enum NSPredicateOperatorType {
        OR = 0,
        AND = 1
    }
    export enum NSPredicateBitwiseOperatorType {
        OR = 0,
        AND = 1,
        XOR = 2
    }
    export enum NSPredicateType {
        Predicate = 0,
        Item = 1,
        Operation = 2
    }
    export class NSPredicateOperator {
        type: any;
        static andPredicateOperatorType(): NSPredicateOperator;
        static orPredicateOperatorType(): NSPredicateOperator;
        constructor(type: any);
    }
    export enum NSPredicateItemValueType {
        Undefined = 0,
        UUID = 1,
        String = 2,
        Number = 3,
        Boolean = 4,
        Null = 5,
        Property = 6
    }
    export class NSPredicateItem {
        relationshipOperation: NSPredicateRelationshipOperatorType;
        bitwiseOperation: NSPredicateBitwiseOperatorType;
        bitwiseKey: string;
        bitwiseValue: any;
        key: any;
        comparator: any;
        value: any;
        valueType: NSPredicateItemValueType;
        evaluateObject(object: any, key?: any, lvalue?: any): boolean;
        evaluateRelationshipObject(object: any): boolean;
        evaluateBitwaseOperatorObject(object: any): boolean;
    }
    export class NSPredicateGroup {
        predicates: any[];
        evaluateObject(object: any): boolean;
    }
    export enum NSPredicateTokenType {
        Identifier = 0,
        UUIDValue = 1,
        StringValue = 2,
        NumberValue = 3,
        BooleanValue = 4,
        NullValue = 5,
        PropertyValue = 6,
        MinorOrEqualComparator = 7,
        MinorComparator = 8,
        MajorOrEqualComparator = 9,
        MajorComparator = 10,
        EqualComparator = 11,
        DistinctComparator = 12,
        ContainsComparator = 13,
        NotContainsComparator = 14,
        InComparator = 15,
        NotIntComparator = 16,
        BitwiseAND = 17,
        BitwiseOR = 18,
        OpenParenthesisSymbol = 19,
        CloseParenthesisSymbol = 20,
        Whitespace = 21,
        AND = 22,
        OR = 23,
        ANY = 24,
        ALL = 25
    }
    export class NSPredicate extends NSObject {
        predicateGroup: any;
        static predicateWithFormat(format: any): NSPredicate;
        initWithFormat(format: any): void;
        readonly predicateFormat: string;
        evaluateObject(object: NSObject): any;
    }
    export function _NSPredicateFilterObjects(objs: any, predicate: any): any;
}

declare module 'foundation/NSSet' {
    import { NSObject } from "foundation/NSObject";
    import { NSPredicate } from "foundation/NSPredicate";
    import "./NSArray";
    export class NSSet extends NSObject {
        static set(): NSSet;
        addObject(object: any): void;
        removeObject(object: any): void;
        removeAllObjects(): void;
        indexOfObject(object: any): number;
        containsObject(object: any): boolean;
        objectAtIndex(index: any): any;
        readonly allObjects: any[];
        readonly count: number;
        readonly length: number;
        copy(): NSSet;
        filterWithPredicate(predicate: NSPredicate): any;
        addObserver(obs: any, keypath: string, context?: any): void;
    }
}

declare module 'foundation/NSIndexPath' {
    import { NSObject } from "foundation/NSObject";
    export function NSIndexPathEqual(indexPath1: NSIndexPath, indexPath2: NSIndexPath): boolean;
    export class NSIndexPath extends NSObject {
        static indexForRowInSection(row: number, section: number): NSIndexPath;
        static indexForColumnInRowAndSection(column: number, row: number, section: number): NSIndexPath;
        add(value: number): void;
        readonly section: any;
        readonly row: any;
        readonly item: any;
        readonly column: any;
        isEqualToIndexPath(indexPath: NSIndexPath): boolean;
    }
}

declare module 'foundation/NSLocale' {
    import { NSObject } from "foundation/NSObject";
    export class NSLocale extends NSObject {
        languageIdentifier: string;
        countryIdentifier: string;
        static currentLocale(): any;
        static _setCurrentLocale(localeIdentifier: string): void;
        initWithLocaleIdentifier(identifer: string): void;
        readonly decimalSeparator: string;
        readonly currencySymbol: string;
        readonly currencyCode: string;
        readonly groupingSeparator: string;
    }
}

declare module 'foundation/NSFormatter' {
    import { NSObject } from "foundation/NSObject";
    export class NSFormatter extends NSObject {
        stringForObjectValue(value: any): any;
        getObjectValueForString(str: string): void;
        editingStringForObjectValue(value: any): void;
        isPartialStringValid(str: string): [boolean, string];
    }
}

declare module 'foundation/NSDateFormatter' {
    import { NSFormatter } from 'foundation/NSFormatter';
    export enum NSDateFormatterStyle {
        NoStyle = 0,
        ShortStyle = 1,
        MediumStyle = 2,
        LongStyle = 3,
        FullStyle = 4
    }
    export class NSDateFormatter extends NSFormatter {
        dateStyle: NSDateFormatterStyle;
        timeStyle: NSDateFormatterStyle;
        init(): void;
        dateFromString(str: string): Date;
        stringFromDate(date: Date): string;
        stringForObjectValue(value: any): string;
        isPartialStringValid(str: string): [boolean, string];
        protected iso8601DateStyle(date: Date): string;
        protected iso8601TimeStyle(date: Date): string;
    }
}

declare module 'foundation/NSISO8601DateFormatter' {
    import { NSDateFormatter } from "foundation/NSDateFormatter";
    export class NSISO8601DateFormatter extends NSDateFormatter {
        static iso8601DateFormatter(): NSISO8601DateFormatter;
        timeZone: any;
        dateFromString(str: string): Date;
        stringFromDate(date: Date): string;
    }
}

declare module 'foundation/NSNumberFormatter' {
    import { NSFormatter } from "foundation/NSFormatter";
    import { NSLocale } from "foundation/NSLocale";
    export enum NSNumberFormatterStyle {
        NoStyle = 0,
        DecimalStyle = 1,
        CurrencyStyle = 2,
        CurrencyISOCodeStyle = 3,
        PercentStyle = 4
    }
    export enum _NSNumberFormatterType {
        Int = 0,
        Decimal = 1
    }
    export class NSNumberFormatter extends NSFormatter {
        numberStyle: NSNumberFormatterStyle;
        locale: NSLocale;
        minimumFractionDigits: number;
        maximumFractionDigits: number;
        groupingSeparator: any;
        currencySymbol: any;
        currencyCode: any;
        init(): void;
        numberFromString(str: string): any;
        stringFromNumber(number: number): string;
        stringForObjectValue(value: any): string;
        isPartialStringValid(str: string): [boolean, string];
    }
}

declare module 'foundation/NSTimer' {
    import { NSObject } from "foundation/NSObject";
    /**
      * Created by godshadow on 21/3/16.
      */
    export class NSTimer extends NSObject {
        static scheduledTimerWithTimeInterval(timeInterval: any, repeat: any, target: any, completion: any): NSTimer;
        initWithTimeInterval(timeInterval: any, repeat: any, target: any, completion: any): void;
        fire(): void;
        invalidate(): void;
    }
}

declare module 'foundation/NSNotificationCenter' {
    /**
      * Created by godshadow on 11/3/16.
      */
    export class NSNotification {
        name: any;
        object: any;
        userInfo: any;
        constructor(name: any, object: any, userInfo: any);
    }
    export class NSNotificationCenter {
        notificationNames: {};
        constructor();
        static defaultCenter(): NSNotificationCenter;
        addObserver(obs: any, name: any, fn: any): void;
        removeObserver(obs: any, name: any): void;
        postNotification(name: any, object: any, userInfo?: any): void;
    }
}

declare module 'foundation/NSUserDefaults' {
    /**
      * Created by godshadow on 29/09/2016.
      */
    export class NSUserDefaults {
        constructor();
        static standardUserDefaults(): NSUserDefaults;
        setBooleanForKey(key: any, value: boolean): void;
        booleanForKey(key: any): boolean;
        setValueForKey(key: string, value: any): void;
        valueForKey(key: string): any;
        removeValueForKey(key: string): void;
    }
}

declare module 'foundation/NSURL' {
    import { NSObject } from "foundation/NSObject";
    export enum NSURLTokenType {
        Protocol = 0,
        Host = 1,
        Path = 2,
        Param = 3,
        Value = 4
    }
    export class NSURL extends NSObject {
        baseURL: NSURL;
        absoluteString: string;
        scheme: string;
        user: string;
        password: any;
        host: string;
        port: number;
        hostname: string;
        path: string;
        file: string;
        pathExtension: string;
        params: any[];
        static urlWithString(urlString: string): NSURL;
        initWithScheme(scheme: string, host: string, path: string): void;
        initWithURLString(urlString: string): void;
        urlByAppendingPathComponent(path: string): NSURL;
        standardizedURL(): NSURL;
    }
}

declare module 'foundation/NSURLRequest' {
    import { NSObject } from "foundation/NSObject";
    import { NSURL } from "foundation/NSURL";
    export class NSURLRequest extends NSObject {
        url: NSURL;
        httpMethod: string;
        httpBody: any;
        headers: any[];
        binary: boolean;
        download: boolean;
        static requestWithURL(url: NSURL): NSURLRequest;
        initWithURL(url: NSURL): void;
        setHeaderField(field: any, value: any): void;
    }
}

declare module 'foundation/NSURLConnection' {
    import { NSURLRequest } from "foundation/NSURLRequest";
    /**
      * Created by godshadow on 14/3/16.
      */
    export class NSURLConnection {
        request: NSURLRequest;
        delegate: any;
        blockFN: any;
        blockTarget: any;
        initWithRequest(request: NSURLRequest, delegate: any): void;
        initWithRequestBlock(request: NSURLRequest, blockTarget: any, blockFN: any): void;
        start(): void;
    }
}

declare module 'foundation/NSXMLParser' {
    import { NSObject } from "foundation/NSObject";
    export interface NSXMLParserDelegate {
        parserDidStartDocument?(parser: NSXMLParser): any;
        parserDidEndDocument?(parser: NSXMLParser): any;
        parserDidStartElement?(parser: NSXMLParser, element: string, attributes: any): any;
        parserDidEndElement?(parser: NSXMLParser, element: string): any;
        parserFoundCharacters?(parser: NSXMLParser, characters: string): any;
        parserFoundComment?(parser: NSXMLParser, comment: string): any;
    }
    export enum NSXMLTokenType {
        Identifier = 0,
        QuestionMark = 1,
        ExclamationMark = 2,
        OpenTag = 3,
        CloseTag = 4,
        Slash = 5,
        Quote = 6,
        WhiteSpace = 7,
        End = 8
    }
    export class NSXMLParser extends NSObject {
        initWithString(str: string, delegate: NSXMLParserDelegate): void;
        parse(): void;
    }
}

declare module 'foundation/NSOperation' {
    import { NSObject } from "foundation/NSObject";
    export class NSOperation extends NSObject {
        name: string;
        target: any;
        completion: any;
        readonly dependencies: any[];
        readonly isExecuting: boolean;
        readonly isFinished: boolean;
        readonly ready: boolean;
        addDependency(operation: NSOperation): void;
        main(): void;
        start(): void;
        executing(): boolean;
        finished(): boolean;
        observeValueForKeyPath(keyPath: string, type: string, object: any, ctx: any): void;
    }
}

declare module 'foundation/NSOperationQueue' {
    import { NSObject } from "foundation/NSObject";
    import { NSOperation } from "foundation/NSOperation";
    import "./NSArray";
    export class NSOperationQueue extends NSObject {
        addOperation(operation: NSOperation): void;
        removeOperation(operation: NSOperation): void;
        readonly operations: any[];
        readonly operationCount: () => any;
        suspended: any;
        observeValueForKeyPath(keyPath: string, type: string, object: any, ctx: any): void;
    }
}

declare module 'foundation/NSBundle' {
    export {};
}

declare module 'foundation/NSLog' {
    export function NSLog(format: any): void;
}

declare module 'foundation/NSNumber' {
    import { NSObject } from "foundation/NSObject";
    export class NSNumber extends NSObject {
        static numberWithBool(value: any): NSNumber;
        static numberWithInteger(value: any): NSNumber;
        static numberWithFloat(value: any): NSNumber;
        protected storeValue: any;
        initWithBool(value: any): void;
        initWithInteger(value: any): void;
        initWithFloat(value: any): void;
    }
}

declare module 'foundation/NSSortDescriptor' {
    import { NSObject } from "foundation/NSObject";
    /**
      * Created by godshadow on 28/09/2016.
      */
    export class NSSortDescriptor extends NSObject {
        key: any;
        ascending: boolean;
        static sortDescriptorWithKey(key: any, ascending: any): NSSortDescriptor;
        initWithKey(key: any, ascending: any): void;
    }
    export function _NSSortDescriptorSortObjects(objs: any, sortDescriptors: any): any;
}

declare module 'foundation/NSPropertyListSerialization' {
    import { NSObject } from "foundation/NSObject";
    import { NSError } from "foundation/NSError";
    import { NSXMLParser } from "foundation/NSXMLParser";
    export enum NSPropertyListReadOptions {
        None = 0
    }
    export enum NSPropertyListFormatformat {
        None = 0
    }
    export class NSPropertyListSerialization extends NSObject {
        static propertyListWithData(data: string, options: NSPropertyListReadOptions, format: NSPropertyListFormatformat, error: NSError): any;
        initWithData(data: string, options: NSPropertyListReadOptions, format: NSPropertyListFormatformat): void;
        parserDidStartElement(parser: NSXMLParser, element: string, attributes: any): void;
        parserFoundCharacters(parser: NSXMLParser, characters: string): void;
        parserDidEndElement(parser: NSXMLParser, element: string): void;
        parserDidEndDocument(parser: NSXMLParser): void;
    }
}

